%define main_release 51
%define samba_version 3.3.8
%define tdb_version 1.1.2
%define talloc_version 1.2.0
%define pre_release %nil

%define samba_release 0%{pre_release}.%{main_release}%{?dist}

%define enable_talloc 1
%define enable_tdb    1
%define enable_clustering 1
%define real_name samba

#only x86_64 has ctdb at the moment
%ifnarch x86_64
%define enable_clustering 0
%endif

Summary: Server and Client software to interoperate with Windows machines
Name: samba3x
Epoch: 0
Version: %{samba_version}
Release: %{samba_release}
License: GPLv3+ and LGPLv3+
Group: System Environment/Daemons
URL: http://www.samba.org/

Source: http://www.samba.org/samba/ftp/samba/samba-%{samba_version}%{pre_release}.tar.gz

# Red Hat specific replacement-files
Source1: samba.log
Source2: samba.xinetd
Source4: samba.sysconfig
Source5: smb.init
Source6: samba.pamd
Source7: smbprint
Source8: winbind.init
Source9: smb.conf.default
Source10: nmb.init
Source11: pam_winbind.conf
Source12: lgpl-3.0.txt

# Don't depend on Net::LDAP
Source999: filter-requires-samba.sh

# upstream patches.  Applied first so that they'll break our patches rather
# than the other way around
# (none right now)

# generic patches
Patch102: samba-3.2.0pre1-pipedir.patch
# The passwd part has been applied, but not the group part
Patch107: samba-3.2.0pre1-grouppwd.patch
Patch200: samba-3.2.5-inotify.patch
Patch303: samba-3.3.9.patch
Patch304: samba-3.3.10.patch
Patch305: samba-3.3.8-cifs_upcall.patch
Patch306: samba-3.3.8-dos_filemode.patch
Patch307: samba-3.3.8-addprinterex.patch

Requires(pre): %{name}-common = %{epoch}:%{samba_version}-%{release}
Requires: pam >= 0:0.64
Requires: logrotate >= 0:3.4
BuildRoot: %{_tmppath}/%{name}-%{samba_version}-%{release}-root
Requires(post): /sbin/chkconfig, /sbin/service
Requires(preun): /sbin/chkconfig, /sbin/service
BuildRequires: pam-devel, readline-devel, ncurses-devel, libacl-devel, krb5-devel, openldap-devel, openssl-devel, cups-devel
BuildRequires: autoconf, gawk, gtk2-devel, libcap-devel, keyutils-libs-devel
%if %enable_clustering
BuildRequires: ctdb-devel
%endif
Conflicts: samba
Conflicts: samba-client
Conflicts: samba-common < 0:3.1

# Working around perl dependency problem from docs
%define __perl_requires %{SOURCE999}


%description

Samba is the suite of programs by which a lot of PC-related machines
share files, printers, and other information (such as lists of
available files and printers). The Windows NT, OS/2, and Linux
operating systems support this natively, and add-on packages can
enable the same thing for DOS, Windows, VMS, UNIX of all kinds, MVS,
and more. This package provides an SMB/CIFS server that can be used to
provide network services to SMB/CIFS clients.
Samba uses NetBIOS over TCP/IP (NetBT) protocols and does NOT
need the NetBEUI (Microsoft Raw NetBIOS frame) protocol.


%package client
Summary: Samba client programs
Group: Applications/System
Requires: %{name}-common = %{epoch}:%{samba_version}-%{release}
Obsoletes: smbfs
Conflicts: samba
Conflicts: samba-client

%description client
The samba-client package provides some SMB/CIFS clients to complement
the built-in SMB/CIFS filesystem in Linux. These clients allow access
of SMB/CIFS shares and printing to SMB/CIFS printers.


%package common
Summary: Files used by both Samba servers and clients
Requires: libtdb >= %{tdb_version}-%{main_release}%{?dist}
Requires: libtalloc >= %{talloc_version}-%{main_release}%{?dist}
Requires: %{name}-winbind = %{epoch}:%{samba_version}-%{release}
Group: Applications/System
Requires(pre): /usr/sbin/groupadd
Requires(post): /sbin/chkconfig, /sbin/service, coreutils
Requires(preun): /sbin/chkconfig, /sbin/service
Conflicts: samba-common < 0:3.1
Conflicts: samba
Conflicts: samba-client
Provides: samba-common = %{epoch}:%{samba_version}-%{release}
Requires: libsmbclient

%description common
Samba-common provides files necessary for both the server and client
packages of Samba.


%package winbind
Summary: Samba winbind
Group: Applications/System
Requires: %{name}-common = %{epoch}:%{samba_version}-%{release}
Requires(pre): /usr/sbin/groupadd
Requires(post): /sbin/chkconfig, /sbin/service, coreutils
Requires(preun): /sbin/chkconfig, /sbin/service
Conflicts: samba-common < 0:3.1

%description winbind
The samba-winbind package provides the winbind daemon, a NSS library, a PAM
module and some client tools. Winbind enables Linux to be a full member in
Windows domains and to use Windows user and group accounts on Linux.


%package winbind-devel
Summary: Developer tools for the winbind library
Group: Development
Requires: %{name}-winbind = %{epoch}:%{samba_version}-%{release}

%description winbind-devel
The samba-winbind package provides developer tools for the wbclient library.


%package swat
Summary: The Samba SMB server Web configuration program
Group: Applications/System
Requires: %{name} = %{epoch}:%{samba_version}-%{release}, xinetd
Conflicts: samba-swat

%description swat
The samba-swat package includes the new SWAT (Samba Web Administration
Tool), for remotely managing Samba's smb.conf file using your favorite
Web browser.


%package doc
Summary: Documentation for the Samba suite
Group: Documentation
Requires: %{name}-common = %{epoch}:%{samba_version}-%{release}
Conflicts: samba

%description doc
The samba-doc package includes all the non-manpage documentation for the
Samba suite.


%package domainjoin-gui
Summary: Domainjoin GUI
Group: Applications/System
Requires: %{name}-common = %{epoch}:%{samba_version}-%{release}, gtk2

%description domainjoin-gui
The samba-domainjoin-gui package includes a domainjoin gtk application.

%if %enable_tdb
%package -n libtdb
Summary: The TDB library and tools
Group: Applications/System
Version: %{tdb_version}
Release: %{main_release}%{?dist}
License: LGPLv3+

%description -n libtdb
The TDB library from the Samba suite.


%package -n tdb-tools
Summary: The TDB tools
Group: Applications/System
Version: %{tdb_version}
Release: %{main_release}%{?dist}
License: GPLv3+
Requires: libtdb = %{epoch}:%{tdb_version}-%{main_release}%{?dist}
Conflicts: samba-common < 0:3.1
Conflicts: samba

%description -n tdb-tools
Some TDB tools from the Samba suite.


%package -n libtdb-devel
Summary: Developer tools for the TDB library
Group: Development
Version: %{tdb_version}
Release: %{main_release}%{?dist}
License: LGPLv3+
Requires: libtdb = %{epoch}:%{tdb_version}-%{main_release}%{?dist}

%description -n libtdb-devel
The libtdb-devel package contains the header files and libraries needed to
develop programs that link against the TDB library in the Samba suite.
%endif

%if %enable_talloc
%package -n libtalloc
Summary: The talloc library
Group: Applications/System
Version: %{talloc_version}
Release: %{main_release}%{?dist}
License: LGPLv3+

%description -n libtalloc
The talloc library from the Samba suite.


%package -n libtalloc-devel
Summary: Developer tools for the talloc library
Group: Development
Version: %{talloc_version}
Release: %{main_release}%{?dist}
Requires: libtalloc = %{epoch}:%{talloc_version}-%{main_release}%{?dist}
License: LGPLv3+

%description -n libtalloc-devel
The libtalloc-devel package contains the header files and libraries needed to
develop programs that link against the talloc library in the Samba suite.
%endif

%prep
# TAG: change for non-pre
%setup -q -T -b 0  -n %{real_name}-%{samba_version}%{pre_release}

# copy Red Hat specific scripts
mkdir packaging/Fedora
cp packaging/RHEL/setup/smbusers packaging/Fedora/
cp %{SOURCE5} packaging/Fedora/
cp %{SOURCE6} packaging/Fedora/
cp %{SOURCE7} packaging/Fedora/
cp %{SOURCE8} packaging/Fedora/winbind.init
cp %{SOURCE9} packaging/Fedora/
cp %{SOURCE10} packaging/Fedora/
cp %{SOURCE11} packaging/Fedora/
cp %{SOURCE12} COPYING-LGPLv3

# Upstream patches 3.3
#(none)
# generic patches 3.3
%patch102 -p1 -b .pipedir
#%patch103 -p1 -b .logfiles
#%patch104 -p1 -b .nmbd-netbiosname # FIXME: does not apply
%patch107 -p1 -b .grouppwd
%patch200 -p0 -b .inotify
%patch303 -p1 -b .3-3-9
%patch304 -p1 -b .3-3-10
%patch305 -p1 -b .cifs_upcall
%patch306 -p1 -b .dos_filemode
%patch307 -p1 -b .addprinterex

mv source/VERSION source/VERSION.orig
sed -e 's/SAMBA_VERSION_VENDOR_SUFFIX=$/&\"%{samba_release}\"/' < source/VERSION.orig > source/VERSION
cd source
script/mkversion.sh
cd ..

#Remove smbldap-tools, they are already packaged separately in Fedora
rm -fr examples/LDAP/smbldap-tools-*/


%build
cd ../%{real_name}-%{samba_version}%{pre_release}/source
sh autogen.sh
%ifarch i386 sparc
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -D_FILE_OFFSET_BITS=64"
%endif
%ifarch ia64
#libtoolize --copy --force     # get it to recognize IA-64
#autoheader
#autoconf
EXTRA="-D_LARGEFILE64_SOURCE"
%endif
CONFIG_OPTS="\
	--with-dnsupdate \
	--with-ads \
	--with-acl-support \
	--with-automount \
	--with-dnsupdate \
	--with-libsmbsharemodes \
	--with-mmap \
	--with-pam \
	--with-pam_smbpass \
	--with-quotas \
	--with-sendfile-support \
	--with-syslog \
	--with-utmp \
	--with-vfs \
	--with-winbind \
	--without-smbwrapper \
	--with-lockdir=/var/lib/samba \
	--with-piddir=/var/run \
	--with-mandir=%{_mandir} \
	--with-privatedir=/var/lib/samba/private \
	--with-logfilebase=/var/log/samba \
	--with-libdir=%{_libdir} \
	--with-modulesdir=%{_libdir}/samba \
	--with-configdir=%{_sysconfdir}/samba \
	--with-pammodulesdir=%{_lib}/security \
	--with-swatdir=%{_datadir}/swat \
	--with-shared-modules=idmap_ad,idmap_rid,idmap_adex,idmap_hash,idmap_tdb2 \
	--with-cifsupcall
"

%if %enable_clustering
	CONFIG_OPTS="$CONFIG_OPTS --with-cluster-support"
%endif

CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -DLDAP_DEPRECATED" %configure $CONFIG_OPTS \
	--without-libsmbclient

make  CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -DLDAP_DEPRECATED" \
	pch

make  LD_LIBRARY_PATH=$RPM_BUILD_DIR/%{real_name}-%{samba_version}/source/bin \
	CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -DLDAP_DEPRECATED" %{?_smp_mflags} \
	all nsswitch/libnss_wins.so modules test_pam_modules test_nss_modules test_shlibs

make  LD_LIBRARY_PATH=$RPM_BUILD_DIR/%{real_name}-%{samba_version}/source/bin \
	CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -DLDAP_DEPRECATED" %{?_smp_mflags} \
	-C lib/netapi/examples

make  CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE" \
	debug2html smbfilter bin/cifs.upcall

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/usr/{sbin,bin}
mkdir -p $RPM_BUILD_ROOT/%{_initrddir}
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/{pam.d,logrotate.d,security}
mkdir -p $RPM_BUILD_ROOT/%{_lib}/security
mkdir -p $RPM_BUILD_ROOT/var/lib/samba
mkdir -p $RPM_BUILD_ROOT/var/lib/samba/private
mkdir -p $RPM_BUILD_ROOT/var/lib/samba/winbindd_privileged
mkdir -p $RPM_BUILD_ROOT/var/lib/samba/scripts
mkdir -p $RPM_BUILD_ROOT/var/log/samba/old
mkdir -p $RPM_BUILD_ROOT/var/spool/samba
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/swat/using_samba
mkdir -p $RPM_BUILD_ROOT/var/run/winbindd
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/samba
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/pkgconfig
mkdir -p $RPM_BUILD_ROOT/%{_libdir} $RPM_BUILD_ROOT/%{_includedir}

cd ../%{real_name}-%{samba_version}%{pre_release}/source

%makeinstall \
	BINDIR=$RPM_BUILD_ROOT%{_bindir} \
	BASEDIR=$RPM_BUILD_ROOT%{_prefix} \
	SBINDIR=$RPM_BUILD_ROOT%{_sbindir} \
	DATADIR=$RPM_BUILD_ROOT%{_datadir} \
	LOCKDIR=$RPM_BUILD_ROOT/var/lib/samba \
	PRIVATEDIR=$RPM_BUILD_ROOT%{_sysconfdir}/samba \
	LIBDIR=$RPM_BUILD_ROOT%{_libdir}/ \
	MODULESDIR=$RPM_BUILD_ROOT%{_libdir}/samba \
	CONFIGDIR=$RPM_BUILD_ROOT%{_sysconfdir}/samba \
	PAMMODULESDIR=$RPM_BUILD_ROOT/%{_lib}/security \
	MANDIR=$RPM_BUILD_ROOT%{_mandir} \
	VARDIR=$RPM_BUILD_ROOT/var/log/samba \
	CODEPAGEDIR=$RPM_BUILD_ROOT%{_libdir}/samba \
	SWATDIR=$RPM_BUILD_ROOT%{_datadir}/swat \
	SAMBABOOK=$RPM_BUILD_ROOT%{_datadir}/swat/using_samba \
	PIDDIR=$RPM_BUILD_ROOT/var/run

cd ..

# Install other stuff
install -m644 packaging/Fedora/smb.conf.default $RPM_BUILD_ROOT%{_sysconfdir}/samba/smb.conf
install -m755 source/script/mksmbpasswd.sh $RPM_BUILD_ROOT%{_bindir}
install -m644 packaging/Fedora/smbusers $RPM_BUILD_ROOT%{_sysconfdir}/samba/smbusers
install -m755 packaging/Fedora/smbprint $RPM_BUILD_ROOT%{_bindir}
install -m755 packaging/Fedora/smb.init $RPM_BUILD_ROOT%{_initrddir}/smb
install -m755 packaging/Fedora/nmb.init $RPM_BUILD_ROOT%{_initrddir}/nmb
install -m755 packaging/Fedora/winbind.init $RPM_BUILD_ROOT%{_initrddir}/winbind
install -m644 packaging/Fedora/pam_winbind.conf $RPM_BUILD_ROOT%{_sysconfdir}/security
#ln -s ../..%{_initrddir}/smb  $RPM_BUILD_ROOT%{_sbindir}/samba
install -m644 packaging/Fedora/samba.pamd $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/samba
install -m644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/samba
echo 127.0.0.1 localhost > $RPM_BUILD_ROOT%{_sysconfdir}/samba/lmhosts
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/openldap/schema
install -m644 examples/LDAP/samba.schema $RPM_BUILD_ROOT%{_sysconfdir}/openldap/schema/samba.schema

# winbind
mkdir -p $RPM_BUILD_ROOT%{_libdir}
install -m 755 source/nsswitch/libnss_winbind.so $RPM_BUILD_ROOT/%{_lib}/libnss_winbind.so.2
ln -sf /%{_lib}/libnss_winbind.so.2  $RPM_BUILD_ROOT%{_libdir}/libnss_winbind.so
install -m 755 source/nsswitch/libnss_wins.so $RPM_BUILD_ROOT/%{_lib}/libnss_wins.so.2
ln -sf /%{_lib}/libnss_wins.so.2  $RPM_BUILD_ROOT%{_libdir}/libnss_wins.so

# libraries {

build_libdir="$RPM_BUILD_ROOT%{_libdir}"

%if %enable_talloc
# talloc
cd source/lib/talloc
# just to get the correct .pc file generated
./autogen.sh && ./configure --prefix=%{_prefix} --libdir=%{_libdir}
cd ../../..
install -m 644 source/lib/talloc/talloc.pc $build_libdir/pkgconfig/
%endif

%if %enable_tdb
# tdb
cd source/lib/tdb
# just to get the correct .pc file generated
./autogen.sh && ./configure --prefix=%{_prefix} --libdir=%{_libdir}
cd ../../..
install -m 644 source/lib/tdb/tdb.pc $build_libdir/pkgconfig/
%endif

# make install puts libraries in the wrong place
# (but at least gets the versioning right now)

list="smbsharemodes netapi talloc tdb wbclient"
#list="smbclient smbsharemodes netapi talloc tdb wbclient"
for i in $list; do
	install -m 644 source/pkgconfig/$i.pc $build_libdir/pkgconfig/ || true
done


/sbin/ldconfig -n $RPM_BUILD_ROOT%{_libdir}/

# }

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d
install -m644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/swat

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/samba
install -m755 $RPM_BUILD_ROOT/usr/sbin/mount.cifs $RPM_BUILD_ROOT/sbin/mount.cifs
install -m755 $RPM_BUILD_ROOT/usr/sbin/umount.cifs $RPM_BUILD_ROOT/sbin/umount.cifs

install -m 755 source/lib/netapi/examples/bin/netdomjoin-gui $RPM_BUILD_ROOT/%{_sbindir}/netdomjoin-gui
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps/%{real_name}
install -m 644 source/lib/netapi/examples/netdomjoin-gui/samba.ico $RPM_BUILD_ROOT/%{_datadir}/pixmaps/%{real_name}/samba.ico
install -m 644 source/lib/netapi/examples/netdomjoin-gui/logo.png $RPM_BUILD_ROOT/%{_datadir}/pixmaps/%{real_name}/logo.png
install -m 644 source/lib/netapi/examples/netdomjoin-gui/logo-small.png $RPM_BUILD_ROOT/%{_datadir}/pixmaps/%{real_name}/logo-small.png

rm -f $RPM_BUILD_ROOT/%{_mandir}/man1/editreg.1*
rm -f $RPM_BUILD_ROOT%{_mandir}/man1/log2pcap.1*
rm -f $RPM_BUILD_ROOT%{_mandir}/man1/smbsh.1*
#rm -f $RPM_BUILD_ROOT%{_mandir}/man1/smbget.1*
rm -f $RPM_BUILD_ROOT%{_mandir}/man5/smbgetrc.5*
rm -f $RPM_BUILD_ROOT%{_mandir}/man1/vfstest.1*
rm -f $RPM_BUILD_ROOT%{_mandir}/man1/testprns.1*
rm -f $RPM_BUILD_ROOT%{_mandir}/man8/smbmount.8*
rm -f $RPM_BUILD_ROOT%{_mandir}/man8/smbmnt.8*
rm -f $RPM_BUILD_ROOT%{_mandir}/man8/smbumount.8*

# why are these getting installed in the wrong place?
rm -f $RPM_BUILD_ROOT%{_sbindir}/{u,}mount.cifs

#Rename ldb tools, as samba3 has an old copy of ldb.
mv -f $RPM_BUILD_ROOT%{_bindir}/ldbadd $RPM_BUILD_ROOT%{_bindir}/ldb3add
mv -f $RPM_BUILD_ROOT%{_bindir}/ldbdel $RPM_BUILD_ROOT%{_bindir}/ldb3del
mv -f $RPM_BUILD_ROOT%{_bindir}/ldbmodify $RPM_BUILD_ROOT%{_bindir}/ldb3modify
mv -f $RPM_BUILD_ROOT%{_bindir}/ldbsearch $RPM_BUILD_ROOT%{_bindir}/ldb3search
mv -f $RPM_BUILD_ROOT%{_bindir}/ldbrename $RPM_BUILD_ROOT%{_bindir}/ldb3rename
mv -f $RPM_BUILD_ROOT%{_bindir}/ldbedit $RPM_BUILD_ROOT%{_bindir}/ldb3edit
mv -f $RPM_BUILD_ROOT%{_mandir}/man1/ldbadd.1 $RPM_BUILD_ROOT%{_mandir}/man1/ldb3add.1
mv -f $RPM_BUILD_ROOT%{_mandir}/man1/ldbdel.1 $RPM_BUILD_ROOT%{_mandir}/man1/ldb3del.1
mv -f $RPM_BUILD_ROOT%{_mandir}/man1/ldbedit.1 $RPM_BUILD_ROOT%{_mandir}/man1/ldb3edit.1
mv -f $RPM_BUILD_ROOT%{_mandir}/man1/ldbmodify.1 $RPM_BUILD_ROOT%{_mandir}/man1/ldb3modify.1
mv -f $RPM_BUILD_ROOT%{_mandir}/man1/ldbsearch.1 $RPM_BUILD_ROOT%{_mandir}/man1/ldb3search.1
mv -f $RPM_BUILD_ROOT%{_mandir}/man1/ldbrename.1 $RPM_BUILD_ROOT%{_mandir}/man1/ldb3rename.1

%if ! %enable_talloc
rm -f $RPM_BUILD_ROOT%{_libdir}/libtalloc.so.*
rm -f $RPM_BUILD_ROOT%{_includedir}/talloc.h
rm -f $RPM_BUILD_ROOT%{_libdir}/libtalloc.so
rm -f $RPM_BUILD_ROOT%{_libdir}/pkgconfig/talloc.pc
%endif

%if ! %enable_tdb
rm -f $RPM_BUILD_ROOT%{_libdir}/libtdb.so.*
rm -f $RPM_BUILD_ROOT%{_includedir}/tdb.h
rm -f $RPM_BUILD_ROOT%{_libdir}/libtdb.so
rm -f $RPM_BUILD_ROOT%{_libdir}/pkgconfig/tdb.pc
rm -f $RPM_BUILD_ROOT%{_bindir}/tdbbackup
rm -f $RPM_BUILD_ROOT%{_bindir}/tdbdump
rm -f $RPM_BUILD_ROOT%{_bindir}/tdbtool
rm -f $RPM_BUILD_ROOT%{_mandir}/man8/tdbbackup.8*
rm -f $RPM_BUILD_ROOT%{_mandir}/man8/tdbdump.8*
rm -f $RPM_BUILD_ROOT%{_mandir}/man8/tdbtool.8*
%endif

rm -f $RPM_BUILD_ROOT%{_includedir}/libsmbclient.h
rm -f $RPM_BUILD_ROOT%{_includedir}/smb_share_modes.h
rm -f $RPM_BUILD_ROOT%{_libdir}/libsmbclient.so*
rm -f $RPM_BUILD_ROOT%{_libdir}/libsmbsharemodes.so*
rm -f $RPM_BUILD_ROOT%{_libdir}/pkgconfig/smbsharemodes.pc
rm -f $RPM_BUILD_ROOT%{_mandir}/man7/libsmbclient.7*

%clean
rm -rf $RPM_BUILD_ROOT

#%pre

%post
/sbin/chkconfig --add smb
/sbin/chkconfig --add nmb
if [ "$1" -ge "1" ]; then
	/sbin/service smb condrestart >/dev/null 2>&1 || :
	/sbin/service nmb condrestart >/dev/null 2>&1 || :
fi
exit 0

%preun
if [ $1 = 0 ] ; then
    /sbin/service smb stop >/dev/null 2>&1 || :
    /sbin/service nmb stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del smb
    /sbin/chkconfig --del nmb
fi
exit 0

#%postun


%pre winbind
/usr/sbin/groupadd -g 88 wbpriv >/dev/null 2>&1 || :

%post winbind
/sbin/chkconfig --add winbind

if [ "$1" -ge "1" ]; then
	/sbin/service winbind condrestart >/dev/null 2>&1 || :
fi

%post common
/sbin/ldconfig

###############################################################################
## We have new default since F-8, time to stop checking for old files are there
## should be none in any support upgrade case
## (keeping it commented just for reference for a while
## 
## # This script must be run always on installs or upgrades
## # it checks if a previous installation have created files
## # under /var/cache/samba and move them in that case as the
## # new package wants them to be under /var/lib/samba for
## # FHS compliance
## #
## # - we must stop the dameon if running and restart it
## #   after the script if it was
## # - we do not overwrite newer files
## # - even if /etc/init.d/smb is in samba and not
## #   samba-common we need to stop smbd/nmbd, if they
## #   are running, here as well, or we will mess up
## #   shared (between winbindd and smbd/nmbd) tdbs
## 
## OLDPATH="/var/cache/samba"
## NEWPATH="/var/lib/samba"
## 
## eval ls $OLDPATH/*.tdb >/dev/null 2>&1
## if [ $? = 0 ]; then
##     eval testparm -s 2>/dev/null |grep "lock dir" >/dev/null
##     if [ $? = 0 ]; then 
## 	echo "Warning: lock dir explicitly set. Not moving tdb files to new default location"
##     else
## 
## 	#Stop daemons before we move the files around
## 
## 	#this is what condrestart checks as well
## 	if [ -f /var/lock/subsys/winbindd ]; then
## 		/sbin/service winbind stop >/dev/null 2>&1 || :
## 		# Use a dirty trick to fool condrestart later
## 		touch /var/lock/subsys/winbindd
## 	fi
## 
## 	if [ -f /var/lock/subsys/smb ]; then
## 		/sbin/service smb stop >/dev/null 2>&1 || :
## 		# We need to stop smbd here as we are moving also smbd owned files
## 		# but we can't restart it until the new server is installed.
## 		# Use a dirty trick to fool condrestart later
## 		touch /var/lock/subsys/smb
## 	fi
## 
## 	if [ -f /var/lock/subsys/nmb ]; then
## 		/sbin/service nmb stop >/dev/null 2>&1 || :
## 		# We need to stop smbd here as we are moving also smbd owned files
## 		# but we can't restart it until the new server is installed.
## 		# Use a dirty trick to fool condrestart later
## 		touch /var/lock/subsys/nmb
## 	fi
## 
## 	eval ls $NEWPATH/*.tdb >/dev/null 2>&1
## 	if [ $? = 0 ]; then
## 		#something strange here, lets backup this stuff and avoid just wiping it
## 
## 		mkdir $NEWPATH.pkgbkp
## 		mv -f $NEWPATH/*.tdb $NEWPATH.pkgbkp/ >/dev/null 2>&1
## 		mv -f $NEWPATH/*.dat $NEWPATH.pkgbkp/ >/dev/null 2>&1
## 		mv -f $NEWPATH/perfmon $NEWPATH.pkgbkp/ >/dev/null 2>&1
## 		mv -f $NEWPATH/printing $NEWPATH.pkgbkp/ >/dev/null 2>&1
## 	fi
## 
## 	mv -f $OLDPATH/*.tdb $NEWPATH/ >/dev/null 2>&1
## 	mv -f $OLDPATH/*.dat $NEWPATH/ >/dev/null 2>&1
## 	mv -f $OLDPATH/perfmon $NEWPATH/ >/dev/null 2>&1
## 	mv -f $OLDPATH/printing $NEWPATH/ >/dev/null 2>&1
## 
##     fi
## fi
## 
## # We also moved private files from /etc/samba to
## # /var/lib/samba/private so we need to migrate these as well
## 
## #secrets.tdb
## if [ -f %{_sysconfdir}/samba/secrets.tdb ]; then
## 	eval testparm -s 2>/dev/null |grep "private dir" >/dev/null
## 	if [ $? = 0 ]; then
## 		echo "Warning: private dir explicitly set. Not moving secrets.tdb to new default location"
## 	else
## 		if [ -f /var/lib/samba/private/secrets.tdb ]; then
## 			mv -f /var/lib/samba/private/secrets.tdb /var/lib/samba/private/secrets.tdb.old
## 		fi
## 		mv -f %{_sysconfdir}/samba/secrets.tdb /var/lib/samba/private/secrets.tdb
## 	fi
## fi
## 
## #smbpasswd
## if [ -f %{_sysconfdir}/samba/smbpasswd ]; then
## 	eval testparm -s 2>/dev/null |grep "smb passwd file" >/dev/null
## 	if [ $? = 0 ]; then
## 		echo "Warning: smbpasswd file location explicitly set. Not moving smbpasswd to new default location"
## 	else
## 		if [ -f /var/lib/samba/private/smbpasswd ]; then
## 			mv -f /var/lib/samba/private/smbpasswd /var/lib/samba/private/smbpasswd.old
## 		fi
## 		mv -f %{_sysconfdir}/samba/smbpasswd /var/lib/samba/private/smbpasswd
## 	fi
## fi
## 
## #passdb.tdb
## if [ -f %{_sysconfdir}/samba/passdb.tdb ]; then
## 	eval testparm -s 2>/dev/null |grep "private dir" >/dev/null || testparm -s 2>/dev/null |grep -P "^\s*passdb\s*backend\s*=.*tdbsam:/etc/samba/passdb.tdb.*"
## 	if [ $? = 0 ]; then
## 		echo "Warning: passdb.tdb location explicitly set. Not moving passdb.tdb to new default location"
## 	else
## 		if [ -f /var/lib/samba/private/passdb.tdb ]; then
## 			mv -f /var/lib/samba/private/passdb.tdb /var/lib/samba/private/passdb.tdb.old
## 		fi
## 		mv -f %{_sysconfdir}/samba/passdb.tdb /var/lib/samba/private/passdb.tdb
## 	fi
## fi
## 
## #remove schannel_store if existing, it is not info we need to keep across restarts
## if [ -f %{_sysconfdir}/samba/schannel_store.tdb ]; then
## 	rm -f %{_sysconfdir}/samba/schannel_store.tdb
## fi
## 
%preun winbind
if [ $1 = 0 ] ; then
    /sbin/service winbind stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del winbind
fi
exit 0

%postun common
/sbin/ldconfig

%if %enable_tdb
%post -n libtdb
/sbin/ldconfig

%postun -n libtdb
/sbin/ldconfig
%endif

%if %enable_talloc
%post -n libtalloc
/sbin/ldconfig

%postun -n libtalloc
/sbin/ldconfig
%endif

%files
%defattr(-,root,root)
%{_sbindir}/smbd
%{_sbindir}/nmbd
%{_bindir}/mksmbpasswd.sh
%{_bindir}/smbstatus
%{_bindir}/eventlogadm
%config(noreplace) %{_sysconfdir}/samba/smbusers
%attr(755,root,root) %{_initrddir}/smb
%attr(755,root,root) %{_initrddir}/nmb
%config(noreplace) %{_sysconfdir}/logrotate.d/samba
%config(noreplace) %{_sysconfdir}/pam.d/samba
%{_mandir}/man7/samba.7*
%{_mandir}/man8/nmbd.8*
%{_mandir}/man8/smbd.8*
%{_mandir}/man8/eventlogadm.8*
%{_mandir}/man8/vfs_*.8*
%{_libdir}/samba/vfs
%{_libdir}/samba/auth
%{_libdir}/samba/charset
%attr(1777,root,root) %dir /var/spool/samba
%dir %{_sysconfdir}/openldap/schema
%{_sysconfdir}/openldap/schema/samba.schema

%doc examples/autofs examples/LDAP examples/libsmbclient examples/misc examples/printer-accounting
%doc examples/printing

%files swat
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/xinetd.d/swat
%{_datadir}/swat
%{_sbindir}/swat
%{_mandir}/man8/swat.8*
%attr(755,root,root) %{_libdir}/samba/*.msg

%files client
%defattr(-,root,root)
/sbin/mount.cifs
/sbin/umount.cifs
%{_sbindir}/cifs.upcall
%{_bindir}/rpcclient
%{_bindir}/smbcacls
%{_bindir}/findsmb
%{_bindir}/smbget
%{_bindir}/nmblookup
%{_bindir}/smbclient
%{_bindir}/smbprint
%{_bindir}/smbspool
%{_bindir}/smbtar
%{_bindir}/smbtree
%{_bindir}/sharesec
%{_mandir}/man1/findsmb.1*
%{_mandir}/man1/nmblookup.1*
%{_mandir}/man1/rpcclient.1*
%{_mandir}/man1/smbcacls.1*
%{_mandir}/man1/smbclient.1*
%{_mandir}/man1/smbtar.1*
%{_mandir}/man1/smbtree.1*
%{_mandir}/man1/smbget.1*
%{_mandir}/man1/sharesec.1*
%{_mandir}/man8/smbspool.8*
%{_mandir}/man8/mount.cifs.8*
%{_mandir}/man8/umount.cifs.8*
%{_mandir}/man8/cifs.upcall.8*

%files common
%defattr(-,root,root)
%attr(755,root,root) /%{_lib}/security/pam_smbpass.so
%dir %{_libdir}/samba
%{_libdir}/samba/lowcase.dat
%{_libdir}/samba/upcase.dat
%{_libdir}/samba/valid.dat
%{_libdir}/libnss_wins.so
/%{_lib}/libnss_wins.so.2
%{_libdir}/libnetapi.so
%attr(755,root,root) %{_libdir}/libnetapi.so.*
%{_includedir}/netapi.h
%{_libdir}/pkgconfig/netapi.pc
%{_bindir}/net
%{_bindir}/testparm
%{_bindir}/smbpasswd
%{_bindir}/pdbedit
%{_bindir}/profiles
%{_bindir}/smbcquotas
%{_bindir}/smbcontrol
%{_bindir}/ldb3add
%{_bindir}/ldb3del
%{_bindir}/ldb3edit
%{_bindir}/ldb3modify
%{_bindir}/ldb3search
%{_bindir}/ldb3rename
%dir /var/lib/samba
%attr(700,root,root) %dir /var/lib/samba/private
%dir /var/lib/samba/scripts
%config(noreplace) %{_sysconfdir}/samba/smb.conf
%config(noreplace) %{_sysconfdir}/samba/lmhosts
%config(noreplace) %{_sysconfdir}/sysconfig/samba
%dir %{_sysconfdir}/samba
%attr(0700,root,root) %dir /var/log/samba
%attr(0700,root,root) %dir /var/log/samba/old
%{_mandir}/man1/ldb3add.1.gz
%{_mandir}/man1/ldb3del.1.gz
%{_mandir}/man1/ldb3edit.1.gz
%{_mandir}/man1/ldb3modify.1.gz
%{_mandir}/man1/ldb3search.1.gz
%{_mandir}/man1/ldb3rename.1.gz
%{_mandir}/man1/profiles.1*
%{_mandir}/man1/smbcquotas.1*
%{_mandir}/man1/smbcontrol.1*
#%{_mandir}/man1/vfstest.1*
%{_mandir}/man1/testparm.1*
%{_mandir}/man1/smbstatus.1*
%{_mandir}/man5/smbpasswd.5*
%{_mandir}/man5/smb.conf.5*
%{_mandir}/man5/lmhosts.5*
%{_mandir}/man8/smbpasswd.8*
%{_mandir}/man8/pdbedit.8*
%{_mandir}/man8/net.8*

%doc README COPYING Manifest 
%doc WHATSNEW.txt Roadmap

%files winbind
%defattr(-,root,root)
%{_bindir}/ntlm_auth
%{_bindir}/wbinfo
%{_libdir}/libnss_winbind.so
%attr(755,root,root) %{_libdir}/libwbclient.so.*
%{_libdir}/samba/idmap
%{_libdir}/samba/nss_info
/%{_lib}/libnss_winbind.so.2
/%{_lib}/security/pam_winbind.so
%{_sbindir}/winbindd
%dir /var/run/winbindd
%attr(750,root,wbpriv) %dir /var/lib/samba/winbindd_privileged
%config(noreplace) %{_sysconfdir}/security/pam_winbind.conf
%{_initrddir}/winbind
%{_mandir}/man1/ntlm_auth.1*
%{_mandir}/man1/wbinfo.1*
%{_mandir}/man8/pam_winbind.8*
%{_mandir}/man7/winbind_krb5_locator.7*
%{_mandir}/man8/winbindd.8*
%{_mandir}/man8/idmap_*.8*
%{_datadir}/locale/*/LC_MESSAGES/pam_winbind.mo

%files winbind-devel
%defattr(-,root,root)
%{_includedir}/wbclient.h
%{_libdir}/libwbclient.so
%{_libdir}/pkgconfig/wbclient.pc

%files doc
%defattr(-,root,root)
%doc docs/Samba3-Developers-Guide.pdf docs/Samba3-ByExample.pdf
%doc docs/Samba3-HOWTO.pdf
%doc docs/htmldocs

%if %enable_talloc
%files -n libtalloc
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/libtalloc.so.*
%doc COPYING-LGPLv3

%files -n libtalloc-devel
%defattr(-,root,root)
%{_includedir}/talloc.h
%{_libdir}/libtalloc.so
%{_libdir}/pkgconfig/talloc.pc
%endif

%if %enable_tdb
%files -n libtdb
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/libtdb.so.*
%doc COPYING-LGPLv3

%files -n libtdb-devel
%defattr(-,root,root)
%{_includedir}/tdb.h
%{_libdir}/libtdb.so
%{_libdir}/pkgconfig/tdb.pc

%files -n tdb-tools
%defattr(-,root,root)
%{_bindir}/tdbbackup
%{_bindir}/tdbdump
%{_bindir}/tdbtool
%{_mandir}/man8/tdbbackup.8*
%{_mandir}/man8/tdbdump.8*
%{_mandir}/man8/tdbtool.8*
%doc COPYING
%endif

%files domainjoin-gui
%defattr(-,root,root)
%{_sbindir}/netdomjoin-gui
%dir %{_datadir}/pixmaps/samba
%{_datadir}/pixmaps/samba/samba.ico
%{_datadir}/pixmaps/samba/logo.png
%{_datadir}/pixmaps/samba/logo-small.png

%changelog
* Wed Mar 10 2010 Guenther Deschner <gdeschner@redhat.com> - 3.3.8-0.51
- Fix panics when using "Add Printer Wizard"
- resolves: #571778

* Wed Jan 20 2010 Guenther Deschner <gdeschner@redhat.com> - 3.3.8-0.50
- Remove 3.0.x libsmbclient
- resolves: #520466

* Fri Jan 08 2010 Guenther Deschner <gdeschner@redhat.com> - 3.3.8-0.49
- Fix "dos filemode = yes" support
- resolves: #537165

* Tue Dec 22 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.8-0.48
- Update cifs.upcall to upstream version
- resolves: #548129

* Fri Dec 11 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.8-0.47
- Make it possible to build samba3x without clustering support
- resolves: #547715

* Tue Nov 10 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.8-0.46
- Fix uninitialized variables in rpc_client code
- related: #527997

* Thu Oct 08 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.8-0.45
- Update to 3.3.8 and add various fixes for Windows 2008 and Windows 7
- resolves: #527997

* Thu Oct 01 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.5-0.43
- Security Release, fixes CVE-2009-1888, CVE-2009-2813, CVE-2009-2948 and CVE-2009-2906
- resolves: #526663

* Thu Sep 03 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.5-0.42
- Add appropriate licensing information to samba3-common, libsmbclient, libtalloc,
  libtdb and tdb-tools
- resolves: #520652

* Tue Aug 04 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.5-0.41
- Fix samr access rights for winbind clients
- related: #506292

* Fri Jun 19 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.5-0.40
- Fix password expiry calculation in pam_winbind
- Remove popt dependency from mount/umount.cifs
- Fix libsmbclient packaging
- resolves: #506932

* Thu Jun 18 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.5-0.39
- remove unused swat.desktop
- related: #506292

* Tue Jun 16 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.5-0.38
- Update to 3.3.5
- resolves: #506292

* Tue May 26 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.4-0.37
- Convert obsolete tags into conflict tags
- Various specfile dependency fixes
- resolves: #502480

* Wed May 20 2009 Guenther Deschner <gdeschner@redhat.com> - 3.3.4-0.34
- Add new package samba3x
- Fix various Requires and Provides tags in order to meet conflict and update
  requirements
- resolves: #454460
